export function GrpcResolver(methodName: string, serviceProperty: string = 'service') {
  return function (
    target: any,
    propertyKey: string,
    descriptor: PropertyDescriptor,
  ) {
    const originalMethod = descriptor.value;
    descriptor.value = async function (...args: any[]) {
      console.log('GrpcResolver args:', args);  // 添加日志
      console.log('First arg:', args[0]);       // 添加日志

      const request = args[0]?.request || args[0];  // 尝试获取 request，如果不存在则使用整个参数

      console.log('Request to be sent:', request);  // 添加日志

      if (!request || !request.brandId) {
        throw new Error(`Invalid request: brandId is required. Received: ${JSON.stringify(request)}`);
      }
      return await this[serviceProperty].execute(methodName, request);

    };
    return descriptor;
  };
} 