import { Injectable } from '@nestjs/common';
import LogHelp from '@dt/log-help';
import { ClsService } from 'nestjs-cls';

LogHelp.setEnvName(process.env.ENV_NAME);
@Injectable()
export class LoggerService {
  constructor(private readonly cls: ClsService) {}

  setCustomContext(key: string, value: any): void {
    this?.cls?.set && this.cls.set(key, value);
  }

  getCustomContext(key: string): any {
    return this?.cls?.get && this.cls.get(key);
  }

  log(...arg: any): void {
    const dtlog = this?.dtlog;
    dtlog?.info(arg);
  }
  info(...arg: any): void {
    const dtlog = this?.dtlog;
    dtlog?.info(arg);
  }
  error(...arg: any): void {
    const dtlog = this?.dtlog;
    dtlog?.error(arg);
  }
  warn(...arg: any): void {
    const dtlog = this?.dtlog;
    dtlog?.yellow(arg);
  }
  debug(...arg: any): void {
    const dtlog = this?.dtlog;
    dtlog?.debug(arg);
  }
  verbose(...arg: any): void {
    const dtlog = this?.dtlog;
    dtlog?.green(arg);
  }

  get url(): string | null {
    return this?.cls?.get && this.cls.get('url');
  }

  get dtlog(): LogHelp {
    const dtlog = this?.cls?.get && this.cls.get('dtlog');
    return dtlog;
  }
  /**
   * 永久日志
   * @param arg
   */
  forever(...arg: any): void {
    this?.dtlog?.set({ url: this.url });
    this?.dtlog?.forever(arg);
  }
}
