import { Args, Context, Mutation, Query, Resolver } from '@nestjs/graphql';
import { TemporalPrintService } from '@/temporalprint/temporalprint.service';

@Resolver('TemporalPrint')
export class TemporalPrintResolver {
  constructor(private readonly service: TemporalPrintService) {}

  @Mutation('UpdateTaskStatus')
  async UpdateTaskStatus(
    @Args('input') input: any,
    @Context() context,
  ): Promise<any> {
    console.log('UpdateTaskStatus', input);
    let result = await this.service.callGrpc(
      'UpdateTaskStatus',
      input,
      context,
    );
    console.log('UpdateTaskStatus result', result);

    if (result == null) {
      result = {
        code: 0,
        msg: 'success',
      };
    }
    return result;
  }
}
