import { Injectable, OnModuleInit } from '@nestjs/common';
import * as path from 'path';
import { join } from 'path';
import { BaseGrpcService } from '@common/base.grpc.service';
import { Client, ClientGrpc, Transport } from '@nestjs/microservices';

const projectRoot = path.resolve(__dirname, '../../..');
const protoPath = join(projectRoot, '/proto/vendor/print-middleplatform-temporal-hera/idl/temporalprint.proto');
const url = `${process.env.G_PRINT_TEMPORALPRINT_GRPC_HOST}:${process.env.G_PRINT_TEMPORALPRINT_GRPC_PORT}`;

@Injectable()
export class TemporalPrintService extends BaseGrpcService implements OnModuleInit {
  @Client({
    transport: Transport.GRPC,
    options: {
      url: url,
      package: 'temporalprint',
      protoPath: protoPath,
    },
  })
  private client: ClientGrpc;

  onModuleInit() {
    this.setServiceClient(this.client, 'TemporalPrintService');
  }

}